library( ANTsR )
library( patchMatchR )
library( keras )
layout( matrix(1:2,nrow=1) )
set.seed( Sys.time() )
fn1 = "brain1.nii.gz"
fn2 = "brain2_lesioned.nii.gz"
rsm = rep( 2, 3 )
img <- antsImageRead( fn1 ) %>% iMath( "Normalize" ) %>% resampleImage( rsm )
img2 <- antsImageRead( fn2 ) %>% iMath( "Normalize" ) %>% resampleImage( rsm )
img2 = antsRegistration( img, img2, "Affine" )$warpedmovout
nP1 = 500
nP2 = 5000
psz = 32
#<#############>oooo<#############>oooo<#############>oooo<#############>oooo###
if ( file.exists( 'brain1_mask.nii.gz') & file.exists( 'brain2_mask.nii.gz') & FALSE ) {
  cat("Use existing masks\n")
  mask = antsImageRead( 'brain1_mask.nii.gz' )
  mask2 = antsImageRead( 'brain2_mask.nii.gz' )
  }
if ( ! exists( "mask"  ) )
  mask = randomMask( getMask( img ), nP1, seed=Sys.time() )# %>% iMath("GD",3)
if ( ! exists( "mask2"  ) )
  mask2 = randomMask( getMask( img2 ), nP2, seed=Sys.time()  )
matchO = deepPatchMatch( img2, img, mask2, mask, psz, psz, verbose = TRUE )
mlm = matchedLandmarks( matchO, img, img2, rep(psz,3) )
#<#############>oooo<#############>oooo<#############>oooo<#############>oooo###
mxct = 16
k = sample(1:nrow( mlm$fixedPoints), mxct )
k = c(404, 231, 365, 312, 363, 477, 259, 175, 417,  33, 229, 490, 117, 336, 136, 103)
lmImage1 = makePointsImage( matrix(mlm$fixedPoints[k,],ncol=3), img, radius = 6 )
lmImage2 = makePointsImage( matrix(mlm$movingPoints[k,],ncol=3), img2, radius = 6 )
layout( matrix(1:2,nrow=2) )
sss = seq( 100/2, 166/2, by = 3 )
plot( img*222, lmImage1, axis=3, slices = sss, ncolumns=length(sss)/2 )
plot( img2*222, lmImage2, axis=3, slices = sss, ncolumns=length(sss)/2 )
